/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.demo.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import so.demo.dao.UbigeoDAO;
import so.demo.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class UbigeoMysqlDAO implements UbigeoDAO {

	@Override
	public JSONObject listarDepartamento(JSONObject parameters) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MySqlDAOFactory.obtenerConexion("nuevo");
			sql = " select codigo_departamento, nombre_departamento from ubigeo "
				+ "GROUP BY codigo_departamento ";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			while (rSet.next()) {
				lista.put(new JSONObject()
					.put("codigoDepartamento", rSet.getInt(1))
					.put("nombreDepartamento", rSet.getString(2))
				);
			}
			response.setStatus(lista.length() > 0);
			response.setMessage(lista.length() > 0 ? "Todo correcto" : "Vamonos alv :v");
			response.setResults(lista);
		} catch (SQLException | JSONException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	public static void main(String[] args) throws Exception {
		UbigeoMysqlDAO dao = new UbigeoMysqlDAO();
		System.out.println("RESPUESTA ----> " + dao.listarDepartamento(new JSONObject()));
	}

}
