   /* global loader, elementLoader, Node */

   const helpers = {
      ajaxPromise(obj) {
         let element = obj.element || ''
         let spinner = obj.element ? elementLoader : loader
         return new Promise((resolve, reject) => {
            $.ajax({
               url: obj.url,
               type: obj.type,
               dataType: obj.dataType,
               data: obj.body,
               beforeSend: (xhr, settings) => {
                  spinner.start(element)
               },
               success: (data, textStatus, jqXHR) => {
                  resolve(data)
               },
               error: (jqXHR, textStatus, errorThrown) => {
                  reject({
                     status: textStatus,
                     message: `Error making the request`,
                     request: obj
                  })
               },
               complete: (jqXHR, textStatus) => {
                  spinner.stop(obj.element)
               }
            })
         })
      }
   }

   const httpRequest = {
      listarDepartamento(parameters) {
         return helpers.ajaxPromise({
            url: '../UbigeoServlet?action=listarDepartamento',
            type: 'POST',
            dataType: 'json',
            body: {
               json: JSON.stringify(parameters)
            },
            element: '#cboDepartamento'
         })
      }
   }

   const DOMEvents = {
      init() {
      },
      changeCboDepartamentos() {

      }
   }

   const initRequest = {
      init() {
         this.cargarDepartamentos()
      },
      cargarDepartamentos() {
         httpRequest.listarDepartamento({})
                 .then(data => {
                    let print = '<option>[SELECCIONE]</option>'
                    if (data.status) {
                       print += data.results.map(obj => `<option value="${obj.codigoDepartamento}">${obj.nombreDepartamento}</option>`)
                    }
                    Node('#cboDepartamento').innerHTML = print
                 })
                 .catch(err => console.log(err))
      }
   }


   const initComponents = {
      init() {
      }
   }

   initialize = () => {
      initRequest.init()
      initComponents.init()
      DOMEvents.init()
   }

   initialize()