   /* global bootbox, Cookies */

   const CONSTANTES = Object.freeze({
      PATH_GENERAL: 'http://localhost:8080/aulaVirtual/',
      PATH_IP: 'http://172.16.2.40:8080/aulaVirtual/',
      CODIGO_PROYECTO_MATRICULA: '25',
      PATH_SERVICIO_REST: 'http://app9.sacooliveros.edu.pe:8080/security-rest/api/'
   })

   let getYearFooter = (footer) => {
      var date = new Date();
      var year = date.getFullYear();
      $(footer).append(year);
   }

   Node = (nodeName) => {
      return document.querySelector(nodeName)
   }

   Nodes = (nodeName) => {
      return document.querySelectorAll(nodeName)
   }

   const capitalizeWords = str => str.split(' ').map((word, i, arr) => word.charAt(0).toUpperCase() + word.slice(1).toLowerCase()).join(' ')

   msnSuccess = (obj = {action: () => {}, message: '¡Éxito!'}) => {
      bootbox.dialog({
         className: "dialogExtraSmall",
         title: "<i class='ace-icon fa fa-tags white'></i> <span class='white'>Notificación</span>",
         headerClass: "modal-bg-success",
         message: obj.message || '¡Éxito!',
         buttons: {
            si: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Aceptar",
               className: "btn bg-green border-green-600 btn-xs",
               callback: obj.action
            }
         }
      })
   }

   msnError = (obj = {action: () => {}, message: '¡Error!'}) => {
      bootbox.dialog({
         className: "dialogExtraSmall",
         title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
         headerClass: "modal-bg-warning",
         message: obj.message || '¡Error!',
         buttons: {
            si: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Aceptar",
               className: "btn bg-orange border-orange-600 btn-xs",
               callback: obj.action
            }
         }
      })
   }

   msnConfirm = (obj = {message :'Exito', action:() => {}}) => {
      bootbox.dialog({
         className: "dialogExtraSmall",
         headerClass: "modal-bg-primary",
         title: "<i class='ace-icon fa fa-check-circle white'></i> <span class='white'>Conformidad</span>",
         message: obj.message || '¿Está seguro?',
         buttons: {
            si: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Si",
               className: "btn-primary",
               callback: () => {
                  obj.action(true)
               }
            },
            no: {
               label: "<i class='fa fa-times bigger-110'></i>&nbsp; No",
               className: "btn-danger",
               callback: () => {
                  obj.action(false)
               }
            }
         }
      })
   }

   deleteAllCookies = () => {
      let cookies = document.cookie.split(";");
      for (let i = 0; i < cookies.length; i++) {
         let cookie = cookies[i];
         let eqPos = cookie.indexOf("=");
         let name = eqPos > -1 ? cookie.substr(0, eqPos) : cookie;
         document.cookie = name + "=;expires=Thu, 01 Jan 1970 00:00:00 GMT";
      }
   }

   logOut = () => {
      $('.logOut').click(() => {
         window.location.href = '../vistas/logout';
      })
   }

   const elementLoader = {
      start: (element) => {
         $(element).parent().block({
            message: '<i class="icon-spinner9 spinner position-left"></i>',
            overlayCSS: {
               backgroundColor: '#fff',
               opacity: 0.8,
               cursor: 'wait'
            },
            css: {
               border: 0,
               padding: 0,
               backgroundColor: 'transparent'
            }
         });
      },
      stop: (element) => {
         $(element).parent().unblock();
      }
   }
   const loader = {
      start: () => {
         $.blockUI({
            message: '<i class="icon-spinner9 spinner position-left" style="font-size:25px"></i>',
            overlayCSS: {
               backgroundColor: '#1b2024',
               opacity: 0.95,
               cursor: 'wait'
            },
            css: {
               border: 0,
               color: '#fff',
               padding: 0,
               backgroundColor: 'transparent'
            }
         });
      },
      stop: () => {
         $.unblockUI();
      }
   }



   jQuery.expr[':'].regex = function (elem, index, match) {
      var matchParams = match[3].split(','),
              validLabels = /^(data|css):/,
              attr = {
                 method: matchParams[0].match(validLabels) ?
                         matchParams[0].split(':')[0] : 'attr',
                 property: matchParams.shift().replace(validLabels, '')
              },
              regexFlags = 'ig',
              regex = new RegExp(matchParams.join('').replace(/^\s+|\s+$/g, ''), regexFlags);
      return regex.test(jQuery(elem)[attr.method](attr.property));
   }

   const ajaxRemoteSelect2 = obj => {
      $(obj.id).select2({
         language: "es",
         allowClear: obj.allowClear || true,
         ajax: {
            url: obj.url,
            dataType: 'json',
            delay: obj.delay || 250,
            type: obj.type || "POST",
            data: obj.data,
            processResults: function (data, params) {
               params.page = params.page || 1;
               return {
                  results: data.items,
                  pagination: {
                     more: (params.page * 10) < data.total_count
                  }
               };
            },
            cache: true
         },
         width: '100%',
         placeholder: obj.placeholder,
         escapeMarkup: function (markup) {
            return markup;
         },
         minimumInputLength: obj.minimumInputLength,
         templateResult: obj.templateResult,
         templateSelection: obj.templateSelection
      });
   }

   getYearFooter('#footerDate');
